
// This file was automatically generated by mmx-extend

#define TID 905215982
#include "glued.hh"


template<class R> ostream&
print_lisp (ostream& out, R x) {
  return out << x;
}

template<class R> R div (R x, R y) { return x/y; }
template<class R> R mod (R x, R y) { return x%y; }

#include <synaps/linalg/VectDse.H>

template<class R> VectDse<R>
build_vector (mmx::glued_tuple<R,TID> a) {
  using namespace mmx;
  int i, len= N(a);
  R* coeffs= new R[len];
  for (i=0; i<len; i++)
    coeffs[i]= a[i];
  return VectDse<R> (len, coeffs);
}

template<class R> ostream&
print_lisp (ostream& out, VectDse<R> v) {
  int i, n= v.size();
  out << "([] ";
  for (i=0; i<n; i++) {
    out << " ";
    (void) print_lisp (out, v[i]);
  }
  out << ")";
  return out;
}

#include <synaps/linalg/MatrDse.H>

template<class R> MatrDse<R>
build_matrix (mmx::glued_tuple<mmx::glued_tuple<R,TID>,TID> a) {
  using namespace mmx;
  int i, j, n= N(a), m= N(a[0]);
  MatrDse<R> M(n,m,a[0][0]);
  for (i=0; i<n; i++)
    for (j=0; j<m; j++)
      M(i,j)= a[i][j];
  return M;
}

template<class R> ostream&
print_lisp (ostream& out, MatrDse<R> M) {
  int i, j, n= M.nbrow(), m=M.nbcol();
  out << "([] (vtuple! ";
  for (i=0; i<n; i++) {
    out << "(tuple! ";
    for (j=0; j<m; j++) {
      if (j>0) out << " ";
      (void) print_lisp (out, M(i,j));
    }
    out << ")";
  }
  out << "))";
  return out;
}

template<typename R> R
access (MatrDse<R> x, int i, int j) {
  return x(i,j);
}

template<typename R> R&
access_alias (MatrDse<R>& x, int i, int j) {
  return x(i,j);
}

#include <synaps/upol/UPolDse.H>

template<typename R> int
deg (UPolDse<R> P) {
  return P.degree();
}

template<typename R> UPolDse<R>
polynomial (mmx::glued_tuple<R,TID> a) {
  using namespace mmx;
  int i, len= N(a);
  R* coeffs= new R[len];
  for (i=0; i<len; i++)
    coeffs[i]= a[i];
  return UPolDse<R> (len, coeffs);
}

template<typename R> ostream&
print_lisp (ostream& out, UPolDse<R> P) {
  out << "(+";
  int i, len= deg(P);
  for (i=len; i>=0; i--) {
    out << " (* ";
    (void) print_lisp (out, P[i]);
    out << " (^ x " << i << "))";
  }
  out << ")";
  return out;
}

template<typename R> VectDse<R>
operator * (R c, VectDse<R> v) {
  return v * c;
}

template<typename R> UPolDse<R>
CUPolDse (R c) {
  R* coeffs= new R[1];
  coeffs[0]= c;
  return UPolDse<R> (1, coeffs);
}

template<typename R> UPolDse<R>
operator + (UPolDse<R> P, R c) {
  return P + CUPolDse (c);
}

template<typename R> UPolDse<R>
operator + (R c, UPolDse<R> P) {
  return P + CUPolDse (c);
}

template<typename R> UPolDse<R>
operator - (UPolDse<R> P, R c) {
  return P - CUPolDse (c);
}

template<typename R> UPolDse<R>
operator - (R c, UPolDse<R> P) {
  return P - CUPolDse (c);
}

template<typename R> UPolDse<R>
operator * (R c, UPolDse<R> P) {
  return P * c;
}

static mmx::type_converter CV;
static mmx::generic ID_1 = mmx::mirror (mmx::symbol ("Vector"));
static mmx::generic ID_2 = mmx::mirror (mmx::symbol ("Matrix"));
static mmx::generic ID_3 = mmx::mirror (mmx::symbol ("Polynomial"));

struct synaps_inst {
  void *rep;
  inline synaps_inst (void *rep2): rep (rep2) {}
};

GENINST_CONVERTERS (synaps_inst);

template<class T, class F> struct converter {
  static inline T
  helper (F x) {
    return (T) x;
  }
};

template<class T> struct converter<T, synaps_inst> {
  static inline T
  helper (synaps_inst x) {
    return *((T*) x.rep);
  }
};

template<class F> struct converter<synaps_inst, F> {
  static inline synaps_inst
  helper (F x) {
    return synaps_inst (new F (x));
  }
};

template<class T> struct converter<T&, synaps_inst& > {
  static inline T
  &helper (synaps_inst &x) {
    return *((T*) x.rep);
  }
};

template<class F> struct converter<synaps_inst&, F& > {
  static inline synaps_inst
  &helper (F &x) {
    return *new synaps_inst (&x);
  }
};

template<class T, class F> inline T
convert (F x) {
  return converter<T, F>::helper (x);
}

template<class T, class F> struct caster {
  static inline T
  helper (F x) {
    return *reinterpret_cast<T* > (&x);
  }
};

template<class T, class F> struct caster<T&, F& > {
  static inline T
  &helper (F &x) {
    return *reinterpret_cast<T* > (&x);
  }
};

template<class T, class F> inline T
cast (F x) {
  return caster<T, F>::helper (x);
}

struct synaps_type_rep;
typedef synaps_type_rep *synaps_type;

struct synaps_type_rep {
  mmx::generic mmxt;
  inline synaps_type_rep () {}
  inline virtual ~synaps_type_rep () {}
  
  virtual bool
  internal () {
    return false;
  }
  
  virtual ostream &gen_lessless (ostream&, synaps_inst);
  virtual synaps_inst gen_new ();
  virtual synaps_inst gen_new (int);
  virtual synaps_inst gen_new (synaps_inst);
  virtual ostream &gen_print_lisp (ostream&, synaps_inst);
  virtual synaps_inst gen_plus (synaps_inst, synaps_inst);
  virtual synaps_inst gen_minus (synaps_inst);
  virtual synaps_inst gen_minus (synaps_inst, synaps_inst);
  virtual synaps_inst gen_times (synaps_inst, synaps_inst);
  virtual synaps_inst gen_over (synaps_inst, synaps_inst);
  virtual synaps_inst gen_div (synaps_inst, synaps_inst);
  virtual synaps_inst gen_mod (synaps_inst, synaps_inst);
  virtual synaps_inst gen_plusassign (synaps_inst&, synaps_inst);
  virtual synaps_inst gen_minusassign (synaps_inst&, synaps_inst);
  virtual synaps_inst gen_timesassign (synaps_inst&, synaps_inst);
  virtual synaps_inst gen_overassign (synaps_inst&, synaps_inst);
  virtual bool gen_equal (synaps_inst, synaps_inst);
  virtual bool gen_unequal (synaps_inst, synaps_inst);
};

GENTYPE_CONVERTERS (synaps_type, synaps_type_rep);

ostream
&operator << (ostream &out, synaps_inst g) {
  cerr << "Fatal error: << should not be called for generics";
  exit (1);
}

ostream
&synaps_type_rep::gen_lessless (ostream &arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<ostream&, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("print"), mmx::value (mmx::as_mmx<ostream&, TID> (arg_1), mmx::ID_OSTREAM), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmx::ID_OSTREAM, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_new () {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::MMX_NEW (mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_new (int arg_1) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::MMX_NEW (mmxt), mmx::value (mmx::as_mmx<int, TID> (arg_1), mmx::ID_INT)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_new (synaps_inst arg_1) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::MMX_NEW (mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

ostream
&synaps_type_rep::gen_print_lisp (ostream &arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<ostream&, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("<<%"), mmx::value (mmx::as_mmx<ostream&, TID> (arg_1), mmx::ID_OSTREAM), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmx::ID_OSTREAM, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_plus (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("+"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_minus (synaps_inst arg_1) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("-"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_minus (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("-"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_times (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("*"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_over (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("/"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_div (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("div!"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_mod (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("mod!"), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_plusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("+="), mmx::value (mmx::as_mmx<synaps_inst&, TID> (arg_1), mmx::list (mmx::ID_ALIAS, mmxt)), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_minusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("-="), mmx::value (mmx::as_mmx<synaps_inst&, TID> (arg_1), mmx::list (mmx::ID_ALIAS, mmxt)), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_timesassign (synaps_inst &arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("*="), mmx::value (mmx::as_mmx<synaps_inst&, TID> (arg_1), mmx::list (mmx::ID_ALIAS, mmxt)), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

synaps_inst
synaps_type_rep::gen_overassign (synaps_inst &arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<synaps_inst, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("/="), mmx::value (mmx::as_mmx<synaps_inst&, TID> (arg_1), mmx::list (mmx::ID_ALIAS, mmxt)), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmxt, mmx::ID_CLASS))));
}

bool
synaps_type_rep::gen_equal (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<bool, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("="), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmx::ID_BOOL, mmx::ID_CLASS))));
}

bool
synaps_type_rep::gen_unequal (synaps_inst arg_1, synaps_inst arg_2) {
  return mmx::as_cpp<bool, TID> (mmx::extern_eval (mmx::list (mmx::MMX_TRANSTYPE, mmx::list (mmx::symbol ("!="), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_1), mmxt), mmx::value (mmx::as_mmx<synaps_inst, TID> (arg_2), mmxt)), mmx::value (mmx::ID_BOOL, mmx::ID_CLASS))));
}

static synaps_type synaps_cur_1;

struct synaps_inst_1 {
  void *rep;
  inline synaps_inst_1 (void *rep2): rep (rep2) {}
  inline synaps_inst_1 (): rep (synaps_cur_1->gen_new ().rep) {}
  inline synaps_inst_1 (int arg_1): rep (synaps_cur_1->gen_new (arg_1).rep) {}
  inline synaps_inst_1 (const synaps_inst_1 &arg_1): rep (synaps_cur_1->gen_new (synaps_inst (arg_1.rep)).rep) {}
  
  inline synaps_inst_1
  &operator = (synaps_inst_1 arg_1) {
    rep = synaps_cur_1->gen_new (synaps_inst (arg_1.rep)).rep;
    return *this;
  }
};

GENINSTX_CONVERTERS (synaps_inst_1, synaps_cur_1);

ostream
&operator << (ostream &arg_1, synaps_inst_1 arg_2) {
  return synaps_cur_1->gen_lessless (arg_1, cast<synaps_inst, synaps_inst_1> (arg_2));
}

ostream
&print_lisp (ostream &arg_1, synaps_inst_1 arg_2) {
  return synaps_cur_1->gen_print_lisp (arg_1, cast<synaps_inst, synaps_inst_1> (arg_2));
}

synaps_inst_1
operator + (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_plus (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator - (synaps_inst_1 arg_1) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_minus (cast<synaps_inst, synaps_inst_1> (arg_1)));
}

synaps_inst_1
operator - (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_minus (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator * (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_times (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator / (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_over (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
div (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_div (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
mod (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_mod (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator += (synaps_inst_1 &arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_plusassign (cast<synaps_inst&, synaps_inst_1& > (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator -= (synaps_inst_1 &arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_minusassign (cast<synaps_inst&, synaps_inst_1& > (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator *= (synaps_inst_1 &arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_timesassign (cast<synaps_inst&, synaps_inst_1& > (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

synaps_inst_1
operator /= (synaps_inst_1 &arg_1, synaps_inst_1 arg_2) {
  return cast<synaps_inst_1, synaps_inst> (synaps_cur_1->gen_overassign (cast<synaps_inst&, synaps_inst_1& > (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2)));
}

bool
operator == (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return synaps_cur_1->gen_equal (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2));
}

bool
operator != (synaps_inst_1 arg_1, synaps_inst_1 arg_2) {
  return synaps_cur_1->gen_unequal (cast<synaps_inst, synaps_inst_1> (arg_1), cast<synaps_inst, synaps_inst_1> (arg_2));
}

struct synaps_VectDse_rep: synaps_type_rep {
  synaps_type x_1;
  inline synaps_VectDse_rep (synaps_type y_1): synaps_type_rep (), x_1 (y_1) {}
  
  bool
  internal () {
    return true;
  }
  
  ostream &gen_lessless (ostream&, synaps_inst);
  synaps_inst gen_new ();
  synaps_inst gen_new (synaps_inst);
  ostream &gen_print_lisp (ostream&, synaps_inst);
  synaps_inst gen_plus (synaps_inst, synaps_inst);
  synaps_inst gen_minus (synaps_inst, synaps_inst);
  synaps_inst gen_plusassign (synaps_inst&, synaps_inst);
  synaps_inst gen_minusassign (synaps_inst&, synaps_inst);
  bool gen_equal (synaps_inst, synaps_inst);
  bool gen_unequal (synaps_inst, synaps_inst);
};

synaps_type
synaps_VectDse (synaps_type x_1) {
  synaps_VectDse_rep *ret = new synaps_VectDse_rep (x_1);
  ret->mmxt = mmx::list (ID_1, mmx::as_mmx<synaps_type, TID> (x_1));
  return ret;
}

ostream
&synaps_VectDse_rep::gen_lessless (ostream &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  ostream &ret = arg_1 << convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_VectDse_rep::gen_new () {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, VectDse<synaps_inst_1> > (VectDse<synaps_inst_1> ());
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_VectDse_rep::gen_new (synaps_inst arg_1) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, VectDse<synaps_inst_1> > (VectDse<synaps_inst_1> (convert<VectDse<synaps_inst_1>, synaps_inst> (arg_1)));
  synaps_cur_1 = save_1;
  return ret;
}

ostream
&synaps_VectDse_rep::gen_print_lisp (ostream &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  ostream &ret = print_lisp (arg_1, convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_VectDse_rep::gen_plus (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, VectDse<synaps_inst_1> > (convert<VectDse<synaps_inst_1>, synaps_inst> (arg_1) + convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_VectDse_rep::gen_minus (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, VectDse<synaps_inst_1> > (convert<VectDse<synaps_inst_1>, synaps_inst> (arg_1) - convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_VectDse_rep::gen_plusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, VectDse<synaps_inst_1> > (convert<VectDse<synaps_inst_1>&, synaps_inst& > (arg_1) += convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_VectDse_rep::gen_minusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, VectDse<synaps_inst_1> > (convert<VectDse<synaps_inst_1>&, synaps_inst& > (arg_1) -= convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

bool
synaps_VectDse_rep::gen_equal (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  bool ret = convert<VectDse<synaps_inst_1>, synaps_inst> (arg_1) == convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

bool
synaps_VectDse_rep::gen_unequal (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  bool ret = convert<VectDse<synaps_inst_1>, synaps_inst> (arg_1) != convert<VectDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

struct synaps_MatrDse_rep: synaps_type_rep {
  synaps_type x_1;
  inline synaps_MatrDse_rep (synaps_type y_1): synaps_type_rep (), x_1 (y_1) {}
  
  bool
  internal () {
    return true;
  }
  
  ostream &gen_lessless (ostream&, synaps_inst);
  synaps_inst gen_new ();
  synaps_inst gen_new (synaps_inst);
  ostream &gen_print_lisp (ostream&, synaps_inst);
  synaps_inst gen_plus (synaps_inst, synaps_inst);
  synaps_inst gen_minus (synaps_inst);
  synaps_inst gen_minus (synaps_inst, synaps_inst);
  synaps_inst gen_times (synaps_inst, synaps_inst);
  synaps_inst gen_plusassign (synaps_inst&, synaps_inst);
  synaps_inst gen_minusassign (synaps_inst&, synaps_inst);
  synaps_inst gen_timesassign (synaps_inst&, synaps_inst);
  bool gen_equal (synaps_inst, synaps_inst);
  bool gen_unequal (synaps_inst, synaps_inst);
};

synaps_type
synaps_MatrDse (synaps_type x_1) {
  synaps_MatrDse_rep *ret = new synaps_MatrDse_rep (x_1);
  ret->mmxt = mmx::list (ID_2, mmx::as_mmx<synaps_type, TID> (x_1));
  return ret;
}

ostream
&synaps_MatrDse_rep::gen_lessless (ostream &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  ostream &ret = arg_1 << convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_new () {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (MatrDse<synaps_inst_1> ());
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_new (synaps_inst arg_1) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (MatrDse<synaps_inst_1> (convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1)));
  synaps_cur_1 = save_1;
  return ret;
}

ostream
&synaps_MatrDse_rep::gen_print_lisp (ostream &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  ostream &ret = print_lisp (arg_1, convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_plus (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1) + convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_minus (synaps_inst arg_1) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (-convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_minus (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1) - convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_times (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1) * convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_plusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (convert<MatrDse<synaps_inst_1>&, synaps_inst& > (arg_1) += convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_minusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (convert<MatrDse<synaps_inst_1>&, synaps_inst& > (arg_1) -= convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_MatrDse_rep::gen_timesassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, MatrDse<synaps_inst_1> > (convert<MatrDse<synaps_inst_1>&, synaps_inst& > (arg_1) *= convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

bool
synaps_MatrDse_rep::gen_equal (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  bool ret = convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1) == convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

bool
synaps_MatrDse_rep::gen_unequal (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  bool ret = convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_1) != convert<MatrDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

struct synaps_UPolDse_rep: synaps_type_rep {
  synaps_type x_1;
  inline synaps_UPolDse_rep (synaps_type y_1): synaps_type_rep (), x_1 (y_1) {}
  
  bool
  internal () {
    return true;
  }
  
  ostream &gen_lessless (ostream&, synaps_inst);
  synaps_inst gen_new ();
  synaps_inst gen_new (int);
  synaps_inst gen_new (synaps_inst);
  ostream &gen_print_lisp (ostream&, synaps_inst);
  synaps_inst gen_plus (synaps_inst, synaps_inst);
  synaps_inst gen_minus (synaps_inst);
  synaps_inst gen_minus (synaps_inst, synaps_inst);
  synaps_inst gen_times (synaps_inst, synaps_inst);
  synaps_inst gen_plusassign (synaps_inst&, synaps_inst);
  synaps_inst gen_minusassign (synaps_inst&, synaps_inst);
  synaps_inst gen_timesassign (synaps_inst&, synaps_inst);
  bool gen_equal (synaps_inst, synaps_inst);
  bool gen_unequal (synaps_inst, synaps_inst);
};

synaps_type
synaps_UPolDse (synaps_type x_1) {
  synaps_UPolDse_rep *ret = new synaps_UPolDse_rep (x_1);
  ret->mmxt = mmx::list (ID_3, mmx::as_mmx<synaps_type, TID> (x_1));
  return ret;
}

ostream
&synaps_UPolDse_rep::gen_lessless (ostream &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  ostream &ret = arg_1 << convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_new () {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (UPolDse<synaps_inst_1> ());
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_new (int arg_1) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (UPolDse<synaps_inst_1> (arg_1));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_new (synaps_inst arg_1) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (UPolDse<synaps_inst_1> (convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1)));
  synaps_cur_1 = save_1;
  return ret;
}

ostream
&synaps_UPolDse_rep::gen_print_lisp (ostream &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  ostream &ret = print_lisp (arg_1, convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_plus (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1) + convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_minus (synaps_inst arg_1) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (-convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_minus (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1) - convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_times (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1) * convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_plusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (convert<UPolDse<synaps_inst_1>&, synaps_inst& > (arg_1) += convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_minusassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (convert<UPolDse<synaps_inst_1>&, synaps_inst& > (arg_1) -= convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

synaps_inst
synaps_UPolDse_rep::gen_timesassign (synaps_inst &arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  synaps_inst ret = convert<synaps_inst, UPolDse<synaps_inst_1> > (convert<UPolDse<synaps_inst_1>&, synaps_inst& > (arg_1) *= convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2));
  synaps_cur_1 = save_1;
  return ret;
}

bool
synaps_UPolDse_rep::gen_equal (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  bool ret = convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1) == convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

bool
synaps_UPolDse_rep::gen_unequal (synaps_inst arg_1, synaps_inst arg_2) {
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = x_1;
  bool ret = convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_1) != convert<UPolDse<synaps_inst_1>, synaps_inst> (arg_2);
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_1 (mmx::generic g) {
  return cons (ID_1, cdr (as_list (g)));
}

static mmx::generic
CONV_1 (mmx::generic g) {
  return mmx::glued<synaps_type, TID> (synaps_VectDse (mmx::as_cpp<synaps_type, TID> (g[1])));
}

static mmx::generic
FUN_2 (mmx::generic g) {
  return cons (ID_2, cdr (as_list (g)));
}

static mmx::generic
CONV_2 (mmx::generic g) {
  return mmx::glued<synaps_type, TID> (synaps_MatrDse (mmx::as_cpp<synaps_type, TID> (g[1])));
}

static mmx::generic
FUN_3 (mmx::generic g) {
  return cons (ID_3, cdr (as_list (g)));
}

static mmx::generic
CONV_3 (mmx::generic g) {
  return mmx::glued<synaps_type, TID> (synaps_UPolDse (mmx::as_cpp<synaps_type, TID> (g[1])));
}

static mmx::generic
FUN_4 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<ostream&, TID> (mmx::as_cpp<ostream&, TID> (h[1]) << mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_5 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<ostream&, TID> (mmx::as_cpp<ostream&, TID> (h[1]) << mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_6 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<ostream&, TID> (mmx::as_cpp<ostream&, TID> (h[1]) << mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_7 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (VectDse<synaps_inst_1> ());
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_8 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (VectDse<synaps_inst_1> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_9 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (build_vector (mmx::glued_tuple<synaps_inst_1, TID> (h)));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_10 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<ostream&, TID> (print_lisp (mmx::as_cpp<ostream&, TID> (h[1]), mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_11 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<synaps_inst_1, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1])[mmx::as_cpp<int, TID> (h[2])]);
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_12 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<synaps_inst_1&, TID> (mmx::as_cpp<VectDse<synaps_inst_1>&, TID> (h[1])[mmx::as_cpp<int, TID> (h[2])]);
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_13 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1]) + mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_14 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1]) - mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_15 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1]) * mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_16 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1]) / mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_17 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>&, TID> (h[1]) += mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_18 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>&, TID> (h[1]) -= mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_19 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>&, TID> (h[1]) *= mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_20 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<VectDse<synaps_inst_1>&, TID> (h[1]) /= mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_21 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<bool, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1]) == mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_22 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<bool, TID> (mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[1]) != mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_23 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (MatrDse<synaps_inst_1> ());
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_24 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (MatrDse<synaps_inst_1> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_25 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (build_matrix (mmx::glued_tuple<mmx::glued_tuple<synaps_inst_1, TID>, TID> (h[1])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_26 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<ostream&, TID> (print_lisp (mmx::as_cpp<ostream&, TID> (h[1]), mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_27 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<synaps_inst_1, TID> (access (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]), mmx::as_cpp<int, TID> (h[2]), mmx::as_cpp<int, TID> (h[3])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_28 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<synaps_inst_1&, TID> (access_alias (mmx::as_cpp<MatrDse<synaps_inst_1>&, TID> (h[1]), mmx::as_cpp<int, TID> (h[2]), mmx::as_cpp<int, TID> (h[3])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_29 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) + mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_30 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (-mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_31 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) - mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_32 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) * mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_33 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<synaps_inst_1, TID> (h[1]) * mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_34 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) * mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_35 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) * mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_36 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>&, TID> (h[1]) += mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_37 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>&, TID> (h[1]) -= mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_38 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<MatrDse<synaps_inst_1>, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>&, TID> (h[1]) *= mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_39 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<bool, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) == mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_40 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<bool, TID> (mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[1]) != mmx::as_cpp<MatrDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_41 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (UPolDse<synaps_inst_1> ());
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_42 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (UPolDse<synaps_inst_1> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_43 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (UPolDse<synaps_inst_1> (mmx::as_cpp<int, TID> (h[1])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_44 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (polynomial<synaps_inst_1> (mmx::glued_tuple<synaps_inst_1, TID> (h)));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_45 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<ostream&, TID> (print_lisp (mmx::as_cpp<ostream&, TID> (h[1]), mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_46 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<synaps_inst_1, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1])[mmx::as_cpp<int, TID> (h[2])]);
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_47 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<synaps_inst_1&, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>&, TID> (h[1])[mmx::as_cpp<int, TID> (h[2])]);
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_48 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) + mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_49 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (-mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_50 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) - mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_51 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) * mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_52 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) * mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_53 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>&, TID> (h[1]) += mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_54 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>&, TID> (h[1]) -= mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_55 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>&, TID> (h[1]) *= mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_56 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>&, TID> (h[1]) *= mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_57 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<bool, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) == mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_58 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<bool, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) != mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_59 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) ^ mmx::as_cpp<int, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_60 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (Diff (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1])));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_61 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<VectDse<synaps_inst_1>, TID> (mmx::as_cpp<synaps_inst_1, TID> (h[1]) * mmx::as_cpp<VectDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_62 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) + mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_63 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<synaps_inst_1, TID> (h[1]) + mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_64 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[1]) - mmx::as_cpp<synaps_inst_1, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_65 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<synaps_inst_1, TID> (h[1]) - mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic
FUN_66 (mmx::generic g) {
  mmx::generic h = g[0];
  synaps_type save_1 = synaps_cur_1;
  synaps_cur_1 = mmx::as_cpp<synaps_type, TID> (g[1]);
  mmx::generic ret = mmx::as_mmx<UPolDse<synaps_inst_1>, TID> (mmx::as_cpp<synaps_inst_1, TID> (h[1]) * mmx::as_cpp<UPolDse<synaps_inst_1>, TID> (h[2]));
  synaps_cur_1 = save_1;
  return ret;
}

static mmx::generic TMPL_1 = mmx::mirror (mmx::symbol ("T1"));

extern "C" void
init_synaps () {
  mmx::register_type_id (TID);
  mmx::extern_declare ("Vector", FUN_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  CV.declare ("CONV_1", ID_1, CONV_1);
  mmx::extern_declare ("Matrix", FUN_2, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  CV.declare ("CONV_2", ID_2, CONV_2);
  mmx::extern_declare ("Polynomial", FUN_3, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_CLASS), mmx::ID_CLASS));
  CV.declare ("CONV_3", ID_3, CONV_3);
  mmx::extern_declare ("print", FUN_4, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, mmx::list (ID_1, TMPL_1)), mmx::ID_OSTREAM)));
  mmx::extern_declare ("print", FUN_5, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, mmx::list (ID_2, TMPL_1)), mmx::ID_OSTREAM)));
  mmx::extern_declare ("print", FUN_6, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, mmx::list (ID_3, TMPL_1)), mmx::ID_OSTREAM)));
  mmx::extern_declare ("vector", FUN_7, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("vector", FUN_8, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("vector", FUN_9, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_TUPLETYPE, TMPL_1), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("<<%", FUN_10, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, mmx::list (ID_1, TMPL_1)), mmx::ID_OSTREAM)));
  mmx::extern_declare (".[]", FUN_11, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), mmx::ID_INT), TMPL_1)));
  mmx::extern_declare (".[]", FUN_12, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_1, TMPL_1)), mmx::ID_INT), mmx::list (mmx::ID_ALIAS, TMPL_1))));
  mmx::extern_declare ("+", FUN_13, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("-", FUN_14, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("*", FUN_15, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), TMPL_1), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("/", FUN_16, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), TMPL_1), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("+=", FUN_17, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("-=", FUN_18, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("*=", FUN_19, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_1, TMPL_1)), TMPL_1), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("/=", FUN_20, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_1, TMPL_1)), TMPL_1), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("=", FUN_21, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), mmx::list (ID_1, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("!=", FUN_22, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_1, TMPL_1), mmx::list (ID_1, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("matrix", FUN_23, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("matrix", FUN_24, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("matrix", FUN_25, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_VTUPLETYPE, mmx::list (mmx::ID_TUPLETYPE, TMPL_1))), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("<<%", FUN_26, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, mmx::list (ID_2, TMPL_1)), mmx::ID_OSTREAM)));
  mmx::extern_declare (".[]", FUN_27, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::ID_INT, mmx::ID_INT), TMPL_1)));
  mmx::extern_declare (".[]", FUN_28, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_2, TMPL_1)), mmx::ID_INT, mmx::ID_INT), mmx::list (mmx::ID_ALIAS, TMPL_1))));
  mmx::extern_declare ("+", FUN_29, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("-", FUN_30, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("-", FUN_31, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("*", FUN_32, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("*", FUN_33, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, TMPL_1, mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("*", FUN_34, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), TMPL_1), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("*", FUN_35, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("+=", FUN_36, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("-=", FUN_37, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("*=", FUN_38, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1)), mmx::list (ID_2, TMPL_1))));
  mmx::extern_declare ("=", FUN_39, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::list (ID_2, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("!=", FUN_40, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_2, TMPL_1), mmx::list (ID_2, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("polynomial", FUN_41, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("polynomial", FUN_42, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("polynomial", FUN_43, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_INT), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("polynomial", FUN_44, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_TUPLETYPE, TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("<<%", FUN_45, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::ID_OSTREAM, mmx::list (ID_3, TMPL_1)), mmx::ID_OSTREAM)));
  mmx::extern_declare (".[]", FUN_46, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::ID_INT), TMPL_1)));
  mmx::extern_declare (".[]", FUN_47, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::ID_INT), mmx::list (mmx::ID_ALIAS, TMPL_1))));
  mmx::extern_declare ("+", FUN_48, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("-", FUN_49, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("-", FUN_50, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*", FUN_51, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*", FUN_52, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("+=", FUN_53, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("-=", FUN_54, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*=", FUN_55, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*=", FUN_56, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, mmx::list (ID_3, TMPL_1)), TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("=", FUN_57, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("!=", FUN_58, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::list (ID_3, TMPL_1)), mmx::ID_BOOL)));
  mmx::extern_declare ("^", FUN_59, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), mmx::ID_INT), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("'", FUN_60, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*", FUN_61, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, TMPL_1, mmx::list (ID_1, TMPL_1)), mmx::list (ID_1, TMPL_1))));
  mmx::extern_declare ("+", FUN_62, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("+", FUN_63, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, TMPL_1, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("-", FUN_64, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (ID_3, TMPL_1), TMPL_1), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("-", FUN_65, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, TMPL_1, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
  mmx::extern_declare ("*", FUN_66, mmx::list (mmx::ID_FORALL, TMPL_1, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, TMPL_1, mmx::list (ID_3, TMPL_1)), mmx::list (ID_3, TMPL_1))));
}

