
/******************************************************************************
* MODULE     : symbols.cc
* DESCRIPTION: frequently used symbols
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <symbols.hh>
namespace mmx {

/******************************************************************************
* Mathemagix keyword names
******************************************************************************/

symbol MMX_ACCESS (".[]");
symbol MMX_AMBIGUOUS ("ambiguous!");
symbol MMX_AND ("&&");
symbol MMX_ASSIGN (":=");
symbol MMX_BACKPRIME ("`");
symbol MMX_BEGIN ("begin!");
symbol MMX_BREAK ("break!");
symbol MMX_CASE ("case!");
symbol MMX_COMPLEMENT ("!!");
symbol MMX_COMPOSE ("@");
symbol MMX_CONTINUE ("continue!");
symbol MMX_CROSS ("Cross");
symbol MMX_DECLARE ("declare!");
symbol MMX_DEFINE ("==");
symbol MMX_DEFINEALIAS (":==");
symbol MMX_DIV ("div");
symbol MMX_DOLLAR ("$");
symbol MMX_DOT (".");
symbol MMX_DOTS ("..");
symbol MMX_ELSE ("else!");
symbol MMX_EQUAL ("=");
symbol MMX_EQUIV ("<=>");
symbol MMX_ERROR ("error!");
symbol MMX_EXISTS ("exists!");
symbol MMX_EXISTSVAL ("existsval!");
symbol MMX_EXPORT ("export!");
symbol MMX_FACTORIAL (".!");
symbol MMX_FOR ("for!");
symbol MMX_FORALL ("forall!");
symbol MMX_FORALLVAL ("forallval!");
symbol MMX_FORIN ("forin!");
symbol MMX_FUNCTION ("->");
symbol MMX_GENERATE ("generate!");
symbol MMX_GTR (">");
symbol MMX_GTREQ (">=");
symbol MMX_GTRGTR (">>");
symbol MMX_HAS ("has!");
symbol MMX_HOLDS ("holds!");
symbol MMX_IF ("if!");
symbol MMX_JOIN ("join!");
symbol MMX_IMPLIES ("=>");
symbol MMX_IMPORT ("import!");
symbol MMX_LAMBDA ("lambda!");
symbol MMX_LESS ("<");
symbol MMX_LESSEQ ("<=");
symbol MMX_LESSLESS ("<<");
symbol MMX_LESSLESS_VAR ("<<*");
symbol MMX_LESSLESS_STR ("<<%");
symbol MMX_LOAD ("load");
symbol MMX_LOCAL ("local!");
symbol MMX_LOOP ("loop!");
symbol MMX_MIGRATE ("migrate!");
symbol MMX_MOD ("mod!");
symbol MMX_MODIFY ("modify!");
symbol MMX_MINUS ("-");
symbol MMX_MINUSASSIGN ("-=");
symbol MMX_NEW_INT ("literal_int!");
symbol MMX_NEW_FLOAT ("literal_float!");
symbol MMX_NEW_STRING ("literal_string!");
symbol MMX_NOT ("!");
symbol MMX_NOTGTR ("!>");
symbol MMX_NOTGTREQ ("!>=");
symbol MMX_NOTLESS ("!<");
symbol MMX_NOTLESSEQ ("!<=");
symbol MMX_NUMBER ("#");
symbol MMX_OBTAIN ("obtain!");
symbol MMX_OMINUS ("@-");
symbol MMX_OOVER ("@/");
symbol MMX_OPLUS ("@+");
symbol MMX_OR ("||");
symbol MMX_OTIMES ("@*");
symbol MMX_OVER ("/");
symbol MMX_OVERASSIGN ("/=");
symbol MMX_PLUS ("+");
symbol MMX_PLUSASSIGN ("+=");
symbol MMX_POSTDEC (".--");
symbol MMX_POSTINC (".++");
symbol MMX_POWER ("^");
symbol MMX_PREDEC ("--");
symbol MMX_PREINC ("++");
symbol MMX_PRIME ("'");
symbol MMX_RETRIEVE ("retrieve");
symbol MMX_RETURN ("return!");
symbol MMX_SEQAND ("and!");
symbol MMX_SEQOR ("or!");
symbol MMX_SPLIT ("split!");
symbol MMX_SQTUPLE ("[]");
symbol MMX_STEP ("step!");
symbol MMX_TIMES ("*");
symbol MMX_TIMESASSIGN ("*=");
symbol MMX_TRANSTYPE (":>");
symbol MMX_TUPLE ("tuple!");
symbol MMX_TUPLETYPE ("Tuple");
symbol MMX_TYPE (":");
symbol MMX_UNEQUAL ("!=");
symbol MMX_UNTIL ("until!");
symbol MMX_USE ("use");
symbol MMX_VCROSS ("VCross");
symbol MMX_VTUPLE ("vtuple!");
symbol MMX_VTUPLETYPE ("VTuple");
symbol MMX_WHILE ("while!");
symbol MMX_XOR ("^^");
symbol MMX_YIELD ("yield!");

/******************************************************************************
* Mathemagix types
******************************************************************************/

symbol MMX_CLASS ("Class");
symbol MMX_GENERIC ("Generic");
symbol MMX_BOOL ("Bool");
symbol MMX_INT ("Int");
symbol MMX_STRING ("String");
symbol MMX_OSTREAM ("OStream");
symbol MMX_OSTRSTREAM ("OStrstream");
symbol MMX_LITERAL_INT ("Literal_Int");
symbol MMX_LITERAL_FLOAT ("Literal_Float");
symbol MMX_LITERAL_STRING ("Literal_String");
symbol MMX_ALIAS ("Alias");
symbol MMX_GENERATOR ("Generator");
symbol MMX_LIST ("List");
symbol MMX_ARRAY ("Array");
symbol MMX_TABLE ("Table");
symbol MMX_POINTER ("Pointer");

mirror ID_CLASS (MMX_CLASS);
mirror ID_GENERIC (MMX_GENERIC);
mirror ID_BOOL (MMX_BOOL);
mirror ID_INT (MMX_INT);
mirror ID_STRING (MMX_STRING);
mirror ID_OSTREAM (MMX_OSTREAM);
mirror ID_OSTRSTREAM (MMX_OSTRSTREAM);
mirror ID_LITERAL_INT (MMX_LITERAL_INT);
mirror ID_LITERAL_FLOAT (MMX_LITERAL_FLOAT);
mirror ID_LITERAL_STRING (MMX_LITERAL_STRING);
mirror ID_ALIAS (MMX_ALIAS);
mirror ID_GENERATOR (MMX_GENERATOR);
mirror ID_LIST (MMX_LIST);
mirror ID_ARRAY (MMX_ARRAY);
mirror ID_TABLE (MMX_TABLE);
mirror ID_POINTER (MMX_POINTER);
mirror ID_CROSS (MMX_CROSS);
mirror ID_TUPLETYPE (MMX_TUPLETYPE);
mirror ID_VCROSS (MMX_VCROSS);
mirror ID_VTUPLETYPE (MMX_VTUPLETYPE);
mirror ID_FUNCTION (MMX_FUNCTION);
mirror ID_FORALL (MMX_FORALL);
mirror ID_EXISTS (MMX_EXISTS);
mirror ID_IMPLIES (MMX_IMPLIES);
mirror ID_AND (MMX_AND);
mirror ID_OR (MMX_OR);
mirror ID_NOT (MMX_NOT);

value VAL_CLASS (ID_CLASS, ID_CLASS);
value VAL_GENERIC (ID_GENERIC, ID_CLASS);
value VAL_BOOL (ID_BOOL, ID_CLASS);
value VAL_INT (ID_INT, ID_CLASS);
value VAL_STRING (ID_STRING, ID_CLASS);
value VAL_OSTREAM (ID_OSTREAM, ID_CLASS);
value VAL_OSTRSTREAM (ID_OSTRSTREAM, ID_CLASS);

/******************************************************************************
* Miscellaneous
******************************************************************************/

symbol CONV_FUNCTION ("0#");
symbol CONV_ARGUMENT ("1#");
symbol CONV_ALIASES ("aliases#");
symbol CONV_AMBIGUOUS ("ambiguous#");
symbol CONV_APPLY ("apply#");
symbol CONV_CROSS ("cross#");
symbol CONV_FORALL ("forall#");
symbol CONV_IGNORE ("ignore#");
symbol CONV_LAMBDA ("lambda#");
symbol CONV_SINGLET ("singlet#");
symbol CONV_TEMPLATE ("template#");
symbol CONV_UNALIAS ("unalias#");
symbol CONV_UNAND ("unand#");
symbol CONV_UNCROSS ("uncross#");
symbol CONV_VCROSS ("vcross#");

symbol CONT_BREAK ("break...");
symbol CONT_RETURN ("return...");
symbol CONT_YIELD ("yield...");
symbol MISC_DONE ("done*");
symbol MISC_GENERATE ("generate*");
symbol MISC_SAVE ("save*");
symbol MISC_TODO ("todo*");
symbol MISC_YIELD ("yield*");

symbol  MMX_VOID ("Void");
generic ID_VOID= list (ID_CROSS);
value   VAL_VOID (ID_VOID, ID_CLASS);
value   VAL_NONE= value (generic (), ID_VOID);
symbol  MMX_EXCEPTION ("Exception");
generic ID_EXCEPTION (MMX_EXCEPTION);
value   VAL_EXCEPTION (ID_EXCEPTION, ID_CLASS);
value   VAL_DONE= value (symbol ("done"), ID_EXCEPTION);
symbol  MMX_UNIVERSAL_VAR ("X#");
generic ID_UNIVERSAL= list (ID_FORALL, MMX_UNIVERSAL_VAR, MMX_UNIVERSAL_VAR);

/******************************************************************************
* The name of the constructor for a given type
******************************************************************************/

symbol
MMX_NEW (generic type) {
  while (is_list (type)) type= car (type);
  while (is_mirror (type)) type= S (as_mirror (type));
  while (is_symbol (type)) type= S (as_symbol (type));
  if (is_string (type)) return symbol (locase (as_string (type)));
  fatal_error ("Bad type", "MMX_NEW", "symbols.cc");
  exit (1);
}

} // namespace mmx
